const char luarocks_admin_cmd_refresh_cache_lua[] =
"\n"
"--- Module implementing the luarocks-admin \"refresh_cache\" command.\n"
"local refresh_cache = {}\n"
"\n"
"local cfg = require(\"luarocks.core.cfg\")\n"
"local cache = require(\"luarocks.admin.cache\")\n"
"\n"
"refresh_cache.help_summary = \"Refresh local cache of a remote rocks server.\"\n"
"refresh_cache.help_arguments = \"[--from=<server>]\"\n"
"refresh_cache.help = [[\n"
"The flag --from indicates which server to use.\n"
"If not given, the default server set in the upload_server variable\n"
"from the configuration file is used instead.\n"
"]]\n"
"\n"
"function refresh_cache.command(flags)\n"
"   local server, upload_server = cache.get_upload_server(flags[\"server\"])\n"
"   if not server then return nil, upload_server end\n"
"   local download_url = cache.get_server_urls(server, upload_server)\n"
"   \n"
"   local ok, err = cache.refresh_local_cache(download_url, cfg.upload_user, cfg.upload_password)\n"
"   if not ok then\n"
"      return nil, err\n"
"   else\n"
"      return true\n"
"   end\n"
"end\n"
"\n"
"\n"
"return refresh_cache\n"
""
;
