const char luarocks_build_command_lua[] =
"\n"
"--- Build back-end for raw listing of commands in rockspec files.\n"
"local command = {}\n"
"\n"
"local fs = require(\"luarocks.fs\")\n"
"local util = require(\"luarocks.util\")\n"
"local cfg = require(\"luarocks.core.cfg\")\n"
"\n"
"--- Driver function for the \"command\" build back-end.\n"
"-- @param rockspec table: the loaded rockspec.\n"
"-- @return boolean or (nil, string): true if no errors occurred,\n"
"-- nil and an error message otherwise.\n"
"function command.run(rockspec)\n"
"   assert(rockspec:type() == \"rockspec\")\n"
"\n"
"   local build = rockspec.build\n"
"   \n"
"   util.variable_substitutions(build, rockspec.variables)\n"
"\n"
"   local env = {\n"
"      CC = cfg.variables.CC,\n"
"      --LD = cfg.variables.LD,\n"
"      --CFLAGS = cfg.variables.CFLAGS,\n"
"   }\n"
"\n"
"   if build.build_command then\n"
"      util.printout(build.build_command)\n"
"      if not fs.execute_env(env, build.build_command) then\n"
"         return nil, \"Failed building.\"\n"
"      end\n"
"   end\n"
"   if build.install_command then\n"
"      util.printout(build.install_command)\n"
"      if not fs.execute_env(env, build.install_command) then\n"
"         return nil, \"Failed installing.\"\n"
"      end\n"
"   end\n"
"   return true\n"
"end\n"
"\n"
"return command\n"
""
;
