const char luarocks_cmd_test_lua[] =
"\n"
"--- Module implementing the LuaRocks \"test\" command.\n"
"-- Tests a rock, compiling its C parts if any.\n"
"local cmd_test = {}\n"
"\n"
"local util = require(\"luarocks.util\")\n"
"local test = require(\"luarocks.test\")\n"
"\n"
"cmd_test.help_summary = \"Run the test suite in the current directory.\"\n"
"cmd_test.help_arguments = \"[--test-type=<type>] [<rockspec>] [-- <args>]\"\n"
"cmd_test.help = [[\n"
"Run the test suite for the Lua project in the current directory.\n"
"If the first argument is a rockspec, it will use it to determine\n"
"the parameters for running tests; otherwise, it will attempt to\n"
"detect the rockspec.\n"
"\n"
"Any additional arguments are forwarded to the test suite. \n"
"To make sure that any flags passed in <args> are not interpreted\n"
"as LuaRocks flags, use -- to separate LuaRocks arguments from\n"
"test suite arguments.\n"
"\n"
"--test-type=<type>  Specify the test suite type manually if it was not\n"
"                    specified in the rockspec and it could not be\n"
"                    auto-detected.\n"
"\n"
"]]..util.deps_mode_help()\n"
"\n"
"function cmd_test.command(flags, argument, ...)\n"
"   assert(type(argument) == \"string\" or not argument)\n"
"\n"
"   local arguments = { ... }\n"
"\n"
"   if argument and argument:match(\"rockspec$\") then\n"
"      return test.run_test_suite(argument, flags[\"test-type\"], arguments)\n"
"   end\n"
"   \n"
"   table.insert(arguments, 1, argument)\n"
"   \n"
"   local rockspec, err = util.get_default_rockspec()\n"
"   if not rockspec then\n"
"      return nil, err\n"
"   end\n"
"\n"
"   return test.run_test_suite(rockspec, flags[\"test-type\"], arguments)\n"
"end\n"
"\n"
"return cmd_test\n"
""
;
