const char luarocks_cmd_which_lua[] =
"\n"
"--- @module luarocks.which_cmd\n"
"-- Driver for the `luarocks which` command.\n"
"local which_cmd = {}\n"
"\n"
"local loader = require(\"luarocks.loader\")\n"
"local cfg = require(\"luarocks.core.cfg\")\n"
"local util = require(\"luarocks.util\")\n"
"\n"
"which_cmd.help_summary = \"Tell which file corresponds to a given module name.\"\n"
"which_cmd.help_arguments = \"<modname>\"\n"
"which_cmd.help = [[\n"
"Given a module name like \"foo.bar\", output which file would be loaded to resolve\n"
"that module by luarocks.loader, like \"/usr/local/lua/]]..cfg.lua_version..[[/foo/bar.lua\".\n"
"]]\n"
"\n"
"--- Driver function for \"lua\" command.\n"
"-- @return boolean This function terminates the interpreter.\n"
"function which_cmd.command(_, modname)\n"
"   local pathname, rock_name, rock_version = loader.which(modname)\n"
"   if not pathname then\n"
"      return nil, \"Module '\" .. modname .. \"' not found by luarocks.loader.\"\n"
"   end\n"
"   util.printout(pathname)\n"
"   util.printout(\"(provided by \" .. tostring(rock_name) .. \" \" .. tostring(rock_version) .. \")\")\n"
"   return true\n"
"end\n"
"\n"
"return which_cmd\n"
"\n"
""
;
