const char luarocks_core_dir_lua[] =
"\n"
"local dir = {}\n"
"\n"
"local require = nil\n"
"--------------------------------------------------------------------------------\n"
"\n"
"--- Describe a path in a cross-platform way.\n"
"-- Use this function to avoid platform-specific directory\n"
"-- separators in other modules. Removes trailing slashes from\n"
"-- each component given, to avoid repeated separators.\n"
"-- Separators inside strings are kept, to handle URLs containing\n"
"-- protocols.\n"
"-- @param ... strings representing directories\n"
"-- @return string: a string with a platform-specific representation\n"
"-- of the path.\n"
"function dir.path(...)\n"
"   local t = {...}\n"
"   while t[1] == \"\" do\n"
"      table.remove(t, 1)\n"
"   end\n"
"   return (table.concat(t, \"/\"):gsub(\"([^:])/+\", \"%1/\"):gsub(\"^/+\", \"/\"):gsub(\"/*$\", \"\"))\n"
"end\n"
"\n"
"--- Split protocol and path from an URL or local pathname.\n"
"-- URLs should be in the \"protocol://path\" format.\n"
"-- For local pathnames, \"file\" is returned as the protocol.\n"
"-- @param url string: an URL or a local pathname.\n"
"-- @return string, string: the protocol, and the pathname without the protocol.\n"
"function dir.split_url(url)\n"
"   assert(type(url) == \"string\")\n"
"   \n"
"   local protocol, pathname = url:match(\"^([^:]*)://(.*)\")\n"
"   if not protocol then\n"
"      protocol = \"file\"\n"
"      pathname = url\n"
"   end\n"
"   return protocol, pathname\n"
"end\n"
"\n"
"return dir\n"
"\n"
""
;
