const char luarocks_download_lua[] =
"local download = {}\n"
"\n"
"local path = require(\"luarocks.path\")\n"
"local fetch = require(\"luarocks.fetch\")\n"
"local search = require(\"luarocks.search\")\n"
"local queries = require(\"luarocks.queries\")\n"
"local fs = require(\"luarocks.fs\")\n"
"local dir = require(\"luarocks.dir\")\n"
"\n"
"local function get_file(filename)\n"
"   local protocol, pathname = dir.split_url(filename)\n"
"   if protocol == \"file\" then\n"
"      local ok, err = fs.copy(pathname, fs.current_dir(), \"read\")\n"
"      if ok then\n"
"         return pathname\n"
"      else\n"
"         return nil, err\n"
"      end\n"
"   else\n"
"      return fetch.fetch_url(filename)\n"
"   end\n"
"end\n"
"\n"
"function download.download(arch, name, version, all)\n"
"   local substring = (all and name == \"\")\n"
"   local query = queries.new(name, version, substring, arch)\n"
"   local search_err\n"
"\n"
"   if all then\n"
"      local results = search.search_repos(query)\n"
"      local has_result = false\n"
"      local all_ok = true\n"
"      local any_err = \"\"\n"
"      for name, result in pairs(results) do\n"
"         for version, items in pairs(result) do\n"
"            for _, item in ipairs(items) do\n"
"               -- Ignore provided rocks.\n"
"               if item.arch ~= \"installed\" then\n"
"                  has_result = true\n"
"                  local filename = path.make_url(item.repo, name, version, item.arch)\n"
"                  local ok, err = get_file(filename)\n"
"                  if not ok then\n"
"                     all_ok = false\n"
"                     any_err = any_err .. \"\\n\" .. err\n"
"                  end\n"
"               end\n"
"            end\n"
"         end\n"
"      end\n"
"\n"
"      if has_result then\n"
"         return all_ok, any_err\n"
"      end\n"
"   else\n"
"      local url\n"
"      url, search_err = search.find_suitable_rock(query, true)\n"
"      if url then\n"
"         return get_file(url)\n"
"      end\n"
"   end\n"
"   return nil, \"Could not find a result named \"..name..(version and \" \"..version or \"\")..\n"
"      (search_err and \": \"..search_err or \".\")\n"
"end\n"
"\n"
"return download\n"
""
;
