const char luarocks_fetch_git_http_lua[] =
"\n"
"--- Fetch back-end for retrieving sources from Git repositories\n"
"-- that use http:// transport. For example, for fetching a repository\n"
"-- that requires the following command line:\n"
"-- `git clone http://example.com/foo.git`\n"
"-- you can use this in the rockspec:\n"
"-- source = { url = \"git+http://example.com/foo.git\" }\n"
"-- Prefer using the normal git:// fetch mode as it is more widely\n"
"-- available in older versions of LuaRocks.\n"
"local git_http = {}\n"
"\n"
"local git = require(\"luarocks.fetch.git\")\n"
"\n"
"--- Fetch sources for building a rock from a local Git repository.\n"
"-- @param rockspec table: The rockspec table\n"
"-- @param extract boolean: Unused in this module (required for API purposes.)\n"
"-- @param dest_dir string or nil: If set, will extract to the given directory.\n"
"-- @return (string, string) or (nil, string): The absolute pathname of\n"
"-- the fetched source tarball and the temporary directory created to\n"
"-- store it; or nil and an error message.\n"
"function git_http.get_sources(rockspec, extract, dest_dir)\n"
"   rockspec.source.url = rockspec.source.url:gsub(\"^git.\", \"\")\n"
"   return git.get_sources(rockspec, extract, dest_dir, \"--\")\n"
"end\n"
"\n"
"return git_http\n"
""
;
