const char luarocks_fetch_hg_http_lua[] =
"\n"
"--- Fetch back-end for retrieving sources from hg repositories\n"
"-- that use http:// transport. For example, for fetching a repository\n"
"-- that requires the following command line:\n"
"-- `hg clone http://example.com/foo`\n"
"-- you can use this in the rockspec:\n"
"-- source = { url = \"hg+http://example.com/foo\" }\n"
"local hg_http = {}\n"
"\n"
"local hg = require(\"luarocks.fetch.hg\")\n"
"\n"
"--- Download sources for building a rock, using hg over http.\n"
"-- @param rockspec table: The rockspec table\n"
"-- @param extract boolean: Unused in this module (required for API purposes.)\n"
"-- @param dest_dir string or nil: If set, will extract to the given directory.\n"
"-- @return (string, string) or (nil, string): The absolute pathname of\n"
"-- the fetched source tarball and the temporary directory created to\n"
"-- store it; or nil and an error message.\n"
"function hg_http.get_sources(rockspec, extract, dest_dir)\n"
"   rockspec.source.url = rockspec.source.url:gsub(\"^hg.\", \"\")\n"
"   return hg.get_sources(rockspec, extract, dest_dir)\n"
"end\n"
"\n"
"return hg_http\n"
""
;
