const char luarocks_results_lua[] =
"local results = {}\n"
"\n"
"local vers = require(\"luarocks.core.vers\")\n"
"local util = require(\"luarocks.util\")\n"
"\n"
"local result_mt = {}\n"
"\n"
"result_mt.__index = result_mt\n"
"\n"
"function result_mt.type()\n"
"   return \"result\"\n"
"end\n"
"\n"
"function results.new(name, version, repo, arch, namespace)\n"
"   assert(type(name) == \"string\" and not name:match(\"/\"))\n"
"   assert(type(version) == \"string\")\n"
"   assert(type(repo) == \"string\")\n"
"   assert(type(arch) == \"string\" or not arch)\n"
"   assert(type(namespace) == \"string\" or not namespace)\n"
"   \n"
"   if not namespace then\n"
"      name, namespace = util.split_namespace(name)\n"
"   end\n"
"   \n"
"   local self = {\n"
"      name = name,\n"
"      version = version,\n"
"      namespace = namespace,\n"
"      arch = arch,\n"
"      repo = repo,\n"
"   }\n"
"\n"
"   return setmetatable(self, result_mt)\n"
"end\n"
"\n"
"--- Test the name field of a query.\n"
"-- If query has a boolean field substring set to true,\n"
"-- then substring match is performed; otherwise, exact string\n"
"-- comparison is done.\n"
"-- @param query table: A query in dependency table format.\n"
"-- @param name string: A package name.\n"
"-- @return boolean: True if names match, false otherwise.\n"
"local function match_name(query, name)\n"
"   if query.substring then\n"
"      return name:find(query.name, 0, true) and true or false\n"
"   else\n"
"      return name == query.name\n"
"   end\n"
"end\n"
"\n"
"--- Returns true if the result satisfies a given query.\n"
"-- @param query: a query.\n"
"-- @return boolean.\n"
"function result_mt:satisfies(query)\n"
"   assert(query:type() == \"query\")\n"
"   return match_name(query, self.name)\n"
"      and (query.arch[self.arch] or query.arch[\"any\"])\n"
"      and ((not query.namespace) or (query.namespace == self.namespace))\n"
"      and vers.match_constraints(vers.parse_version(self.version), query.constraints)\n"
"end\n"
"\n"
"return results\n"
""
;
