const char luarocks_signing_lua[] =
"local signing = {}\n"
"\n"
"local cfg = require(\"luarocks.core.cfg\")\n"
"local fs = require(\"luarocks.fs\")\n"
"\n"
"local function get_gpg()\n"
"   local vars = cfg.variables\n"
"   local gpg = vars.GPG\n"
"   local gpg_ok, err = fs.is_tool_available(gpg, \"gpg\")\n"
"   if not gpg_ok then\n"
"      return nil, err\n"
"   end\n"
"   return gpg\n"
"end\n"
"\n"
"function signing.signature_url(url)\n"
"   return url .. \".asc\"\n"
"end\n"
"\n"
"function signing.sign_file(file)\n"
"   local gpg, err = get_gpg()\n"
"   if not gpg then\n"
"      return nil, err\n"
"   end\n"
"   \n"
"   local sigfile = file .. \".asc\"\n"
"   if fs.execute(gpg, \"--armor\", \"--output\", sigfile, \"--detach-sign\", file) then\n"
"      return sigfile\n"
"   else\n"
"      return nil, \"failed running \" .. gpg .. \" to sign \" .. file\n"
"   end\n"
"end\n"
"\n"
"function signing.verify_signature(file, sigfile)\n"
"   local gpg, err = get_gpg()\n"
"   if not gpg then\n"
"      return nil, err\n"
"   end\n"
"\n"
"   if fs.execute(gpg, \"--verify\", sigfile, file) then\n"
"      return true\n"
"   else\n"
"      return nil, \"GPG returned a verification error\"\n"
"   end\n"
"\n"
"end\n"
"\n"
"return signing\n"
""
;
