const char luarocks_test_lua[] =
"\n"
"local test = {}\n"
"\n"
"local fetch = require(\"luarocks.fetch\")\n"
"local deps = require(\"luarocks.deps\")\n"
"\n"
"local test_types = {\n"
"   \"busted\",\n"
"   \"command\",\n"
"}\n"
"\n"
"local test_modules = {}\n"
"\n"
"for _, test_type in ipairs(test_types) do\n"
"   local mod = require(\"luarocks.test.\" .. test_type)\n"
"   table.insert(test_modules, mod)\n"
"   test_modules[test_type] = mod\n"
"   test_modules[mod] = test_type\n"
"end\n"
"\n"
"local function get_test_type(rockspec)\n"
"   if rockspec.test and rockspec.test.type then\n"
"      return rockspec.test.type\n"
"   end\n"
"   \n"
"   for _, test_module in ipairs(test_modules) do\n"
"      if test_module.detect_type() then\n"
"         return test_modules[test_module]\n"
"      end\n"
"   end\n"
"   \n"
"   return nil, \"could not detect test type -- no test suite for \" .. rockspec.package .. \"\?\"\n"
"end\n"
"\n"
"-- Run test suite as configured in rockspec in the current directory.\n"
"function test.run_test_suite(rockspec_arg, test_type, args)\n"
"   local rockspec\n"
"   if type(rockspec_arg) == \"string\" then\n"
"      local err, errcode\n"
"      rockspec, err, errcode = fetch.load_rockspec(rockspec_arg)\n"
"      if err then\n"
"         return nil, err, errcode\n"
"      end\n"
"   else\n"
"      assert(type(rockspec_arg) == \"table\")\n"
"      rockspec = rockspec_arg\n"
"   end\n"
"   \n"
"   if not test_type then\n"
"      local err\n"
"      test_type, err = get_test_type(rockspec, test_type)\n"
"      if not test_type then\n"
"         return nil, err\n"
"      end\n"
"   end\n"
"   assert(test_type)\n"
"\n"
"   if next(rockspec.test_dependencies) then\n"
"      local ok, err, errcode = deps.fulfill_dependencies(rockspec, \"test_dependencies\", \"all\")\n"
"      if err then\n"
"         return nil, err, errcode\n"
"      end\n"
"   end\n"
"\n"
"   local mod_name = \"luarocks.test.\" .. test_type\n"
"   local pok, test_mod = pcall(require, mod_name)\n"
"   if not pok then\n"
"      return nil, \"failed loading test execution module \" .. mod_name\n"
"   end\n"
"   \n"
"   return test_mod.run_tests(rockspec.test, args)\n"
"end\n"
"\n"
"return test\n"
""
;
