const char luarocks_test_busted_lua[] =
"\n"
"local busted = {}\n"
"\n"
"local fs = require(\"luarocks.fs\")\n"
"local deps = require(\"luarocks.deps\")\n"
"local path = require(\"luarocks.path\")\n"
"local dir = require(\"luarocks.dir\")\n"
"local queries = require(\"luarocks.queries\")\n"
"\n"
"local unpack = table.unpack or unpack\n"
"\n"
"function busted.detect_type()\n"
"   if fs.exists(\".busted\") then\n"
"      return true\n"
"   end\n"
"   return false\n"
"end\n"
"\n"
"function busted.run_tests(test, args)\n"
"   if not test then\n"
"      test = {}\n"
"   end\n"
"\n"
"   local ok, bustedver, where = deps.fulfill_dependency(queries.new(\"busted\"))\n"
"   if not ok then\n"
"      return nil, bustedver\n"
"   end\n"
"\n"
"   local busted_exe\n"
"   if test.busted_executable then\n"
"      busted_exe = test.busted_executable\n"
"   else\n"
"      busted_exe = dir.path(path.root_dir(where), \"bin\", \"busted\")\n"
"\n"
"      -- Windows fallback\n"
"      local busted_bat = dir.path(path.root_dir(where), \"bin\", \"busted.bat\")\n"
"\n"
"      if not fs.exists(busted_exe) and not fs.exists(busted_bat) then\n"
"         return nil, \"'busted' executable failed to be installed\"\n"
"      end\n"
"   end\n"
"\n"
"   if type(test.flags) == \"table\" then\n"
"      -- insert any flags given in test.flags at the front of args\n"
"      for i = 1, #test.flags do\n"
"         table.insert(args, i, test.flags[i])\n"
"      end\n"
"   end\n"
"\n"
"   local err\n"
"   ok, err = fs.execute(busted_exe, unpack(args))\n"
"   if ok then\n"
"      return true\n"
"   else\n"
"      return nil, err or \"test suite failed.\"\n"
"   end\n"
"end\n"
"\n"
"\n"
"return busted\n"
""
;
