const char luarocks_test_command_lua[] =
"\n"
"local command = {}\n"
"\n"
"local fs = require(\"luarocks.fs\")\n"
"local dir = require(\"luarocks.dir\")\n"
"local cfg = require(\"luarocks.core.cfg\")\n"
"\n"
"local unpack = table.unpack or unpack\n"
"\n"
"function command.detect_type()\n"
"   if fs.exists(\"test.lua\") then\n"
"      return true\n"
"   end\n"
"   return false\n"
"end\n"
"\n"
"function command.run_tests(test, args)\n"
"   if not test then\n"
"      test = {\n"
"         script = \"test.lua\"\n"
"      }\n"
"   end\n"
"   \n"
"   if not test.script and not test.command then\n"
"      test.script = \"test.lua\"\n"
"   end\n"
"\n"
"   if type(test.flags) == \"table\" then\n"
"      -- insert any flags given in test.flags at the front of args\n"
"      for i = 1, #test.flags do\n"
"         table.insert(args, i, test.flags[i])\n"
"      end\n"
"   end\n"
"   \n"
"   local ok\n"
"\n"
"   if test.script then\n"
"      if not fs.exists(test.script) then\n"
"         return nil, \"Test script \" .. test.script .. \" does not exist\"\n"
"      end\n"
"      local lua = fs.Q(dir.path(cfg.variables[\"LUA_BINDIR\"], cfg.lua_interpreter))  -- get lua interpreter configured\n"
"      ok = fs.execute(lua, test.script, unpack(args))\n"
"   elseif test.command then\n"
"      ok = fs.execute(test.command, unpack(args))\n"
"   end\n"
"\n"
"   if ok then\n"
"      return true\n"
"   else\n"
"      return nil, \"tests failed with non-zero exit code\"\n"
"   end\n"
"end\n"
"\n"
"return command\n"
""
;
