const char luarocks_type_manifest_lua[] =
"local type_manifest = {}\n"
"\n"
"local type_check = require(\"luarocks.type_check\")\n"
"\n"
"local manifest_formats = type_check.declare_schemas({\n"
"   [\"3.0\"] = {\n"
"      repository = {\n"
"         _mandatory = true,\n"
"         -- packages\n"
"         _any = {\n"
"            -- versions\n"
"            _any = {\n"
"               -- items\n"
"               _any = {\n"
"                  arch = { _type = \"string\", _mandatory = true },\n"
"                  modules = { _any = { _type = \"string\" } },\n"
"                  commands = { _any = { _type = \"string\" } },\n"
"                  dependencies = { _any = { _type = \"string\" } },\n"
"                  -- TODO: to be extended with more metadata.\n"
"               }\n"
"            }\n"
"         }\n"
"      },\n"
"      modules = {\n"
"         _mandatory = true,\n"
"         -- modules\n"
"         _any = {\n"
"            -- providers\n"
"            _any = { _type = \"string\" }\n"
"         }\n"
"      },\n"
"      commands = {\n"
"         _mandatory = true,\n"
"         -- modules\n"
"         _any = {\n"
"            -- commands\n"
"            _any = { _type = \"string\" }\n"
"         }\n"
"      },\n"
"      dependencies = {\n"
"         -- each module\n"
"         _any = {\n"
"            -- each version\n"
"            _any = {\n"
"               -- each dependency\n"
"               _any = {\n"
"                  name = { _type = \"string\" },\n"
"                  namespace = { _type = \"string\" },\n"
"                  constraints = {\n"
"                     _any = {\n"
"                        no_upgrade = { _type = \"boolean\" },\n"
"                        op = { _type = \"string\" },\n"
"                        version = {\n"
"                           string = { _type = \"string\" },\n"
"                           _any = { _type = \"number\" },\n"
"                        }\n"
"                     }\n"
"                  }\n"
"               }\n"
"            }\n"
"         }\n"
"      }\n"
"   }\n"
"})\n"
"\n"
"--- Type check a manifest table.\n"
"-- Verify the correctness of elements from a \n"
"-- manifest table, reporting on unknown fields and type\n"
"-- mismatches.\n"
"-- @return boolean or (nil, string): true if type checking\n"
"-- succeeded, or nil and an error message if it failed.\n"
"function type_manifest.check(manifest, globals)\n"
"   assert(type(manifest) == \"table\")\n"
"   local format = manifest_formats[\"3.0\"]\n"
"   local ok, err = type_check.check_undeclared_globals(globals, format)\n"
"   if not ok then return nil, err end\n"
"   return type_check.type_check_table(\"3.0\", manifest, format, \"\")\n"
"end\n"
"\n"
"return type_manifest\n"
""
;
