const char luarocks_upload_multipart_lua[] =
"\n"
"local multipart = {}\n"
"\n"
"local File = {}\n"
"\n"
"local unpack = unpack or table.unpack\n"
"\n"
"-- socket.url.escape(s) from LuaSocket 3.0rc1\n"
"function multipart.url_escape(s)\n"
"   return (string.gsub(s, \"([^A-Za-z0-9_])\", function(c)\n"
"      return string.format(\"%%%02x\", string.byte(c))\n"
"   end))\n"
"end\n"
"\n"
"function File:mime()\n"
"   if not self.mimetype then\n"
"      local mimetypes_ok, mimetypes = pcall(require, \"mimetypes\")\n"
"      if mimetypes_ok then\n"
"         self.mimetype = mimetypes.guess(self.fname)\n"
"      end\n"
"      self.mimetype = self.mimetype or \"application/octet-stream\"\n"
"   end\n"
"   return self.mimetype\n"
"end\n"
"\n"
"function File:content()\n"
"   local fd = io.open(self.fname, \"rb\")\n"
"   if not fd then\n"
"      return nil, \"Failed to open file: \"..self.fname\n"
"   end\n"
"   local data = fd:read(\"*a\")\n"
"   fd:close()\n"
"   return data\n"
"end\n"
"\n"
"local function rand_string(len)\n"
"   local shuffled = {}\n"
"   for i = 1, len do\n"
"      local r = math.random(97, 122)\n"
"      if math.random() >= 0.5 then\n"
"        r = r - 32\n"
"      end\n"
"      shuffled[i] = r\n"
"   end\n"
"   return string.char(unpack(shuffled))\n"
"end\n"
"\n"
"-- multipart encodes params\n"
"-- returns encoded string,boundary\n"
"-- params is an a table of tuple tables:\n"
"-- params = {\n"
"--   {key1, value2},\n"
"--   {key2, value2},\n"
"--   key3: value3\n"
"-- }\n"
"function multipart.encode(params)\n"
"   local tuples = { }\n"
"   for i = 1, #params do\n"
"      tuples[i] = params[i]\n"
"   end\n"
"   for k,v in pairs(params) do\n"
"      if type(k) == \"string\" then\n"
"         table.insert(tuples, {k, v})\n"
"      end\n"
"   end\n"
"   local chunks = {}\n"
"   for _, tuple in ipairs(tuples) do\n"
"      local k,v = unpack(tuple)\n"
"      k = multipart.url_escape(k)\n"
"      local buffer = { 'Content-Disposition: form-data; name=\"' .. k .. '\"' }\n"
"      local content\n"
"      if type(v) == \"table\" and v.__class == File then\n"
"         buffer[1] = buffer[1] .. ('; filename=\"' .. v.fname:gsub(\".*/\", \"\") .. '\"')\n"
"         table.insert(buffer, \"Content-type: \" .. v:mime())\n"
"         content = v:content()\n"
"      else\n"
"         content = v\n"
"      end\n"
"      table.insert(buffer, \"\")\n"
"      table.insert(buffer, content)\n"
"      table.insert(chunks, table.concat(buffer, \"\\r\\n\"))\n"
"   end\n"
"   local boundary\n"
"   while not boundary do\n"
"      boundary = \"Boundary\" .. rand_string(16)\n"
"      for _, chunk in ipairs(chunks) do\n"
"         if chunk:find(boundary) then\n"
"            boundary = nil\n"
"            break\n"
"         end\n"
"      end\n"
"   end\n"
"  local inner = \"\\r\\n--\" .. boundary .. \"\\r\\n\"\n"
"  return table.concat({ \"--\", boundary, \"\\r\\n\",\n"
"                        table.concat(chunks, inner),\n"
"                        \"\\r\\n\", \"--\", boundary, \"--\", \"\\r\\n\" }), boundary\n"
"end\n"
"\n"
"function multipart.new_file(fname, mime)\n"
"   local self = {}\n"
"   setmetatable(self, { __index = File })\n"
"   self.__class = File\n"
"   self.fname = fname\n"
"   self.mimetype = mime\n"
"   return self\n"
"end\n"
"\n"
"return multipart\n"
"\n"
""
;
